1ae226ab3e6eb10386b86b499519cc43b56b2ca4
[util-vserver.git] / scripts / vrpm
1 #! /bin/bash
2 # $Id: vrpm,v 1.13 2005/01/27 21:24:44 ensc Exp $
3
4 # Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
5 #  
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; version 2 of the License.
9 #  
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #  
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
18
19 : ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
20 test -e "$UTIL_VSERVER_VARS" || {
21     echo $"Can not find util-vserver installation (the file '$UTIL_VSERVER_VARS' would be expected); aborting..." >&2
22     exit 1
23 }
24 . "$UTIL_VSERVER_VARS"
25 . "$_LIB_FUNCTIONS"
26
27 function showHelp()
28 {
29     echo \
30 $"Usage: $0 <vserver-name>* [--all] [--quiet|-q] [--help] [--version] [--unify] -- <rpm-params>+
31
32 Report bugs to <$PACKAGE_BUGREPORT>."
33
34     exit $1
35 }
36
37 function showVersion()
38 {
39     echo \
40 $"vrpm $PACKAGE_VERSION -- rpm for vservers
41 This program is part of $PACKAGE_STRING
42
43 Copyright (C) 2003 Enrico Scholz
44 This program is free software; you may redistribute it under the terms of
45 the GNU General Public License.  This program has absolutely no warranty."
46     
47     exit $1
48 }
49
50 do_unify=
51 is_quiet=
52 declare -a vservers=()
53
54 while test "$#" -ge 1; do
55     case "$1" in
56         --quiet|-q)
57             is_quiet=1
58             ;;
59         --all)
60             getAllVservers tmp
61             vservers=( "${vservers[@]}" "${tmp[@]}" )
62             ;;
63         --unify)
64             do_unify=1
65             ;;
66         --)
67             shift; break;;
68         --help)
69             showHelp 0;;
70         --version)
71             showVersion 0;;
72         *)  vservers=( "${vservers[@]}" "$1" )
73      esac
74      shift
75 done
76
77 test "$#" -ge 1 || showHelp 1 >&2
78 test "${#vservers[@]}" -ne 1 || is_quiet=1
79
80 cnt=0
81 res=255
82
83 for i in "${vservers[@]}"; do
84     cnt=$[ cnt + 1 ]
85
86     test -n "$is_quiet" || {
87         colorize bold echo -n "vrpm: operating on vserver "
88         colorize bold colorize emph echo "$i"
89         xtermTitle "vrpm: operating on vserver '$i'  [$cnt/${#vservers[@]}]"
90     }
91
92     if pkgmgmt.isInternal "$i"; then
93         $_VSERVER "$i" exec rpm "$@"
94     else
95         callInNamespace "$i" \
96             "$_VNAMESPACE" --new -- "$_VRPM_WORKER" "$i" "$@"
97     fi
98     res=$?
99
100     test $res -eq 0 -o "$is_quiet" || {
101         colorize error echo -n $"vrpm failed on vserver '$i' with errorcode $res"
102         echo
103     }
104
105     test -n "$is_quiet" || echo
106 done
107
108 test -z "$do_unify" || echo "unify currently unsupported" >&2
109 test "$cnt" -ge 0   || echo "No vservers specified" >&2
110 exit $res